; 
    include \masm32\include\masm32rt.inc
; 
    .data
      hInst     dd          0
      hWnd      dd          0
      hwndPop1  dd          0
      hwndPop2  dd          0
      hwndPop3  dd          0
      _X        dd          0
      _Y        dd          0
      wcx       WNDCLASSEX  <>
      msg       MSG         <>
    .code
; 
CreatePopup proc _x:DWORD, _y:DWORD, wd:DWORD, ht:DWORD,
                 hParent:DWORD, pszText:DWORD

    LOCAL hwnd:DWORD

    mov wcx.style,         CS_BYTEALIGNWINDOW
    mov wcx.lpfnWndProc,   OFFSET PopupProc
    mov wcx.cbClsExtra,    NULL
    mov wcx.cbWndExtra,    NULL
    m2m wcx.hInstance,     hInst
    mov wcx.hbrBackground, rv(GetStockObject, LTGRAY_BRUSH)
    mov wcx.lpszMenuName,  NULL
    mov wcx.lpszClassName, chr$("popup_class")
    mov wcx.hIcon,         rv(LoadIcon, NULL, IDI_APPLICATION)
    mov wcx.hCursor,       rv(LoadCursor, NULL, IDC_ARROW)
    mov wcx.hIconSm,       0

    invoke RegisterClassEx, ADDR wcx
    invoke CreateWindowEx,  NULL,
                            chr$("popup_class"),
                            chr$("Test"),
                            WS_VISIBLE or WS_CHILD or WS_BORDER,
                            _x, _y, wd, ht,
                            hParent, NULL,
                            hInst, NULL
    mov hwnd, eax

    invoke CreateWindowEx,0,
            chr$("STATIC"), pszText,
            WS_CHILD or WS_VISIBLE or SS_LEFT,
            10, 3, 170, 25, hwnd, 100,
            hInst, NULL

    invoke CreateWindowEx,0,
            chr$("BUTTON"),chr$("x"),
            WS_CHILD or WS_VISIBLE,
            178, 3, 18, 22, hwnd, 101,
            hInst, NULL

    invoke ShowWindow, hwnd, SW_SHOWNORMAL
    invoke UpdateWindow, hwnd

    return hwnd

CreatePopup endp
; 
PopupProc proc hwnd:DWORD, uMsg:DWORD, wParam:DWORD, lParam:DWORD
    SWITCH uMsg
      CASE WM_COMMAND
        .IF wParam == 101
          invoke DestroyWindow, hwnd
        .ENDIF
      CASE WM_DESTROY
        invoke DestroyWindow, hwnd
    ENDSW
    invoke DefWindowProc, hwnd, uMsg, wParam, lParam
    ret
PopupProc endp
; 
WindowProc proc hwnd:DWORD, uMsg:DWORD, wParam:DWORD, lParam:DWORD
    SWITCH uMsg
      CASE WM_KEYDOWN
        SWITCH wParam
          CASE VK_F1
            .IF rv(IsWindow, hwndPop1) == 0
              invoke CreatePopup, 1, 1, 200, 30,
                                  hwnd, chr$("Test Message 1")
              mov hwndPop1, eax
           .ENDIF
          CASE VK_F2
            .IF rv(IsWindow, hwndPop2) == 0
              invoke CreatePopup,1,33, 200, 30,
                                 hwnd, chr$("Test Message 2")
              mov hwndPop2, eax
            .ENDIF
          CASE VK_F3
            .IF rv(IsWindow, hwndPop3) == 0
              invoke CreatePopup,1, 65, 200, 30,
                                 hwnd, chr$("Test Message 3")
              mov hwndPop3, eax
            .ENDIF
        ENDSW
      CASE WM_CLOSE
        invoke PostQuitMessage, NULL
      CASE WM_DESTROY
        invoke DestroyWindow, hwnd
    ENDSW
    invoke DefWindowProc, hwnd, uMsg, wParam, lParam
    ret
WindowProc endp
; 
start:
; 
    mov hInst, rv(GetModuleHandle, NULL)
    mov wcx.cbSize,        sizeof WNDCLASSEX
    mov wcx.style,         CS_HREDRAW or CS_VREDRAW \
                              or CS_BYTEALIGNWINDOW
    mov wcx.lpfnWndProc,   OFFSET WindowProc
    mov wcx.cbClsExtra,    NULL
    mov wcx.cbWndExtra,    NULL
    m2m wcx.hInstance,     hInst
    mov wcx.hbrBackground, rv(GetStockObject, WHITE_BRUSH)
    mov wcx.lpszMenuName,  NULL
    mov wcx.lpszClassName, chr$("test_class")
    mov wcx.hIcon,         rv(LoadIcon, NULL, IDI_APPLICATION)
    mov wcx.hCursor,       rv(LoadCursor, NULL, IDC_ARROW)
    mov wcx.hIconSm,       0

    invoke RegisterClassEx, ADDR wcx

    W = 400
    H = 300
    invoke GetSystemMetrics, SM_CXSCREEN
    shr eax, 1
    sub eax, W / 2
    mov _X, eax
    invoke GetSystemMetrics, SM_CYSCREEN
    shr eax, 1
    sub eax, H / 2
    mov _Y, eax

    invoke CreateWindowEx,  WS_EX_OVERLAPPEDWINDOW,
                            chr$("test_class"),
                            chr$("Test"),
                            WS_OVERLAPPED or WS_SYSMENU,
                            _X, _Y, W, H,
                            NULL, NULL,
                            hInst, NULL
    mov hWnd, eax
    invoke ShowWindow, hWnd, SW_SHOWNORMAL
    invoke UpdateWindow, hWnd
  msgLoop:
    invoke GetMessage, ADDR msg, NULL, 0, 0
    .IF eax != 0
      invoke TranslateMessage, ADDR msg
      invoke DispatchMessage, ADDR msg
      jmp   msgLoop
    .ENDIF
    exit msg.wParam

; 

end start
